class Scanner

def initialize(scanarray)
	@@namesArray=scanarray[0]
	@@tokenArray=scanarray[1]
end

# ==zerlege(input)
# Diese Methode zerlegt einen Eingabestring in seine Bestandteile,
# die durch Ruby-Patterns gegeben sind
# Allerdings werden die einzelnen Teile nicht den Tokenklassen zugeordnet,
# sondern nur in ein Array geschrieben, welches von der Methode dann
# zurckgegeben wird. 

def zerlege(input)
  ergarray=Array.new(0)
	
	# Zusammenstellen des regulren Ausdrucks aus dem Token-Array
	tempStr="\\A("
	@@tokenArray.each do |regex|
		tempStr=tempStr+regex.source+"|"
	end
	tempStr=tempStr.chomp("|")
	tempStr=tempStr+("\)")
	tempRegexp=Regexp.new(tempStr)
	#print tempRegexp.source

  while (input.size > 0) do
    tokentemp=""
    c=(input.match(tempRegexp))
    if (c[0]!=nil and input.index(c[0])==0)
			tokentemp=c[0]
		end
    if(tokentemp=="")
			return Array.new
    end
    ergarray << tokentemp
    input=input.sub(tokentemp, '')
		input=input.strip
  end   
  return ergarray
end

def bestimmeToken(text)
@@namesArray.each do |name|
	index=@@namesArray.index(name)
	return name if @@tokenArray[index].match(text).to_s == text
end
end

def bestimme(input)
  zerlege(input).each do |part|
    print(bestimmeToken(part))
    print(" <<",part,">>\n")
  end
end

end

=begin
regScanner=Scanner.new([["auf","zu","gauf","gzu","eauf","ezu","senkr","bis","var","zeichen"],
												[/[(]/,/[)]/,/\{/,/\}/,/\[/,/\]/,/[|]/,/[-]/,/\$\w/,/\S/]])

example="{$x|[a-$z]}"

erg = regScanner.zerlege(example)

if erg.empty?
  print "Irregulaere Eingabe"
	
else
  print("+------------------------------------------------+\n")
  print("| Zerlegung ohne Zuordnung zu den Token-Klassen: |\n")
  print("+------------------------------------------------+\n\n")
  erg.each do |comp|
      print("<<",comp,">>  ")
  end
  print("\n\n")
  print("+-----------------------------------------------+\n")
  print("| Zerlegung mit Zuordnung zu den Token-Klassen: |\n")
  print("+-----------------------------------------------+\n\n")
  print("Akkumulierte Tokens: \n--------------------\n\n")
  regScanner.bestimme(example)

end
=end
